///////////////////////////////////////////////////////////////////////////////////////
// 
// Serial Port Processing
///////////////////////////////////////////////////////////////////////////////////////
int PairMiss =0;
elapsedMillis GPSMon;
int GPSHz = 0;

void serialDataOut()
{
  // Create single text parameter and print it
  #ifdef coutD
    debugGPS();
  #endif

  rtk.upDated = false;

  cout.printf("%10.6f, %10.6f, %10.6f, %8.6f, %d",
           timeStamp*0.001, rtk.utcTime, IMU_RX_time*0.000001f,
           _dt, rtk.fixType);
  cout.printf("%12.8lf,%12.8lf,%10.4f", rtk.lat1, rtk.lon1, rtk.hMSL);
  cout.printf("%10.4f,%10.4f,%10.4f", rtk.velN, rtk.velE, rtk.velD);
  cout.printf("%10.4f,%10.4f,%10.4f", ypr[1], ypr[2], ypr[0]);
  cout.printf("%10.4f,%10.4f,%10.4f\n",aNEDx1, aNEDy1, aNEDz1);
}


void serialPortOut(){  
  // Set textLength to the number of parameters to print * 31
  int  textLength = 16 * 31;
  char text[textLength];
  
  //Temporary text parameters
  char acc_xText[30];
  char acc_yText[30];
  char acc_zText[30];
  char accNED_xText[30];
  char accNED_yText[30];
  char accNED_zText[30];
  char dtText[30];
  
  char utcText[30];
  char fixTypeText[30];
  char latText[30];
  char lonText[30];
  char altText[30];
  char velNText[30];
  char velEText[30];
  char velDText[30];
  
  char pitchText[30];
  char rollText[30];
  char yawText[30];
  char tS_Text[30];
  
  dtostrf(timeStamp*0.001,10,6, tS_Text);          
  dtostrf(utcTime, 10, 10, utcText);
  dtostrf(_dt, 10, 10, dtText);
  
  dtostrf(uBloxData.fixType, 10, 7, fixTypeText);
  dtostrf(uBloxData.lat, 10, 7, latText);
  dtostrf(uBloxData.lon, 10, 7, lonText);
  dtostrf(uBloxData.height, 10, 7, altText);
  dtostrf(uBloxData.velN, 10, 4, velNText);
  dtostrf(uBloxData.velE, 10, 4, velEText);
  dtostrf(uBloxData.velD, 10, 4, velDText);

  dtostrf(ypr[1], 10, 4, pitchText);
  dtostrf(ypr[2], 10, 4, rollText);
  dtostrf(ypr[0], 10, 4, yawText);

  dtostrf(aNEDx1, 10, 4, accNED_xText);
  dtostrf(aNEDy1, 10, 4, accNED_yText);
  dtostrf(aNEDz1, 10, 4, accNED_zText);
  
  rtk.upDated = false;

  // Create single text parameter and print it
  snprintf(text, textLength, "%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s",
           tS_Text, utcText, dtText, fixTypeText,
           latText, lonText, altText,
           velNText, velEText, velDText,
           pitchText, rollText, yawText,
           accNED_xText, accNED_yText, accNED_zText);
  cout.println(text); 
}    
 

void debugGPS()
{
    if(timeStamp*0.001 > 260.0 && timeStamp*0.001< 300.0) 
        incMissed++;
    if(rtk.upDated){
      GPSHz++;
      if ( GPSMon >= 950 ) {
        coutD.print( "--------\n" );
        GPSHz = 1;
        GPSMon =0;
      }
      coutD.print(incMissed); coutD.print(" **** ");
       
      coutD.print( "\t @" );
            char utcText[30];
      dtostrf(utcTime, 10, 10, utcText);
      coutD.print( utcText );

      coutD.print( "\t ms" );
      coutD.print( GPSMon );
      coutD.print( "==" );
      coutD.print( GPSHz ); 
      coutD.print( " || " );
      coutD.print("\n");
    }
}
